#include<iostream>

using namespace std;

const int MAXN = 505;

int n, m;
int a[MAXN][MAXN];

void read()
{
    cin >> n >> m;
    for(int i = 0;i<n;i++)
    {
        string input;
        cin >> input;

        for(int j = 0;j<m;j++) a[i][j] = input[j] - '0';
    }
}

int digDiff[15][15];

int addDp[MAXN];
int dpUp[MAXN][MAXN], dpDown[MAXN][MAXN];
int dpLeft[MAXN][MAXN], dpRight[MAXN][MAXN];

void initDigit(int d)
{
    for(int j = 0;j<m;j++) dpUp[0][j] = digDiff[d][ a[0][j] ];
    for(int i = 1;i<n;i++)
    {
        for(int j = 0;j<m;j++)
        {
            dpUp[i][j] = digDiff[d][ a[i][j] ];

            addDp[j] = dpUp[i-1][j];
            if(j!=0) addDp[j] = min(addDp[j], dpUp[i][j-1]+addDp[j-1]);
        }
        for(int j = m-1;j>=0;j--)
        {
            if(j!=m-1) addDp[j] = min(addDp[j], dpUp[i][j+1]+addDp[j+1]);
        }
        for(int j = 0;j<m;j++)
        {
            dpUp[i][j] += addDp[j];
        }
    }

    for(int j = 0;j<m;j++) dpDown[n-1][j] = digDiff[d][ a[n-1][j] ];
    for(int i = n-2;i>=0;i--)
    {
        for(int j = 0;j<m;j++)
        {
            dpDown[i][j] = digDiff[d][ a[i][j] ];

            addDp[j] = dpDown[i+1][j];
            if(j!=0) addDp[j] = min(addDp[j], dpDown[i][j-1]+addDp[j-1]);
        }
        for(int j = m-1;j>=0;j--)
        {
            if(j!=m-1) addDp[j] = min(addDp[j], dpDown[i][j+1]+addDp[j+1]);
        }
        for(int j = 0;j<m;j++)
        {
            dpDown[i][j] += addDp[j];
        }
    }


    ///////////////////////////////

    for(int i = 0;i<n;i++) dpLeft[i][0] = digDiff[d][ a[i][0] ];
    for(int j = 1;j<m;j++)
    {
        for(int i = 0;i<n;i++)
        {
            dpLeft[i][j] = digDiff[d][ a[i][j] ];

            addDp[i] = dpLeft[i][j-1];
            if(i!=0) addDp[i] = min(addDp[i], dpLeft[i-1][j]+addDp[i-1]);
        }
        for(int i = n-1;i>=0;i--)
        {
            if(i!=n-1) addDp[i] = min(addDp[i], dpLeft[i+1][j]+addDp[i+1]);
        }
        for(int i = 0;i<n;i++)
        {
            dpLeft[i][j] += addDp[i];
        }
    }

    for(int i = 0;i<n;i++) dpRight[i][m-1] = digDiff[d][ a[i][m-1] ];
    for(int j = m-1;j>=0;j--)
    {
        for(int i = 0;i<n;i++)
        {
            dpRight[i][j] = digDiff[d][ a[i][j] ];

            addDp[i] = dpRight[i][j+1];
            if(i!=0) addDp[i] = min(addDp[i], dpRight[i-1][j]+addDp[i-1]);
        }
        for(int i = n-1;i>=0;i--)
        {
            if(i!=n-1) addDp[i] = min(addDp[i], dpRight[i+1][j]+addDp[i+1]);
        }
        for(int i = 0;i<n;i++)
        {
            dpRight[i][j] += addDp[i];
        }
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    read();

    for(int d1 = 0;d1<=9;d1++)
    {
        for(int d2 = d1;d2<=9;d2++)
        {
            digDiff[d1][d2] = d2 - d1;
            digDiff[d2][d1] = d2 - d1;
        }
    }

    int answer = MAXN*MAXN*10;
    for(int d = 0;d<=9;d++)
    {
        initDigit(d);

        //cout << " --------- " << d << " --------- " << '\n';

        for(int i = 0;i<n;i++)
        {
            for(int j = 0;j<m;j++)
            {
                answer = min(answer, dpUp[i][j]+dpDown[i][j]+dpLeft[i][j]+dpRight[i][j]-3*digDiff[d][ a[i][j] ]);
                //cout << i << " " << j << " -> " << answer << " " << dpLeft[i][j] << " " << dpDown[i][j] << " " << dpUp[i][j] << " " << dpRight[i][j] << '\n';
            }
        }
    }

    cout << answer << '\n';
}
/*
3 3
919
111
919
*/
