#include<iostream>
#include<vector>
#include<bitset>

using namespace std;

const int MAXN = 5e5 + 5;
const int MAXT = 5005;

int n, m, t;
vector <int> graph[MAXN];
vector <pair <int, int>> node2Flights[MAXN], node2FlightsInv[MAXN];

int dp[MAXT];
pair <int, int> flights[MAXT];
vector <int> flightGraph[MAXT];

vector <int> filter(vector <int> &v)
{
    vector <int> out;
    for(int x: v)
    {
        if(node2Flights[x].size()>0) out.push_back(x);
    }

    return out;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m >> t;
    for(int i = 0;i<n;i++)
    {
        int k;
        cin >> k;

        for(int j = 0;j<k;j++)
        {
            int x;
            cin >> x;

            graph[i].push_back(x);
        }
    }
    for(int i = 0;i<t;i++)
    {
        int u, v;
        cin >> u >> v;

        flights[i] = {u, v};
        node2Flights[u].push_back({v, i});
        node2FlightsInv[v].push_back({u, i});
    }

    for(int x = 0;x<n;x++)
    {
        for(int y: graph[x])
        {
            if(y==x) continue;

            for(int i = 0;i<node2FlightsInv[x].size();i++)
            {
                for(int j = node2Flights[y].size()-1;j>=0;j--)
                {
                    if(node2Flights[y][j].second<=node2FlightsInv[x][i].second) break;
                    flightGraph[ node2FlightsInv[x][i].second ].push_back(node2Flights[y][j].second);

                    //accessible[ node2Flights[y][j].second ][ node2Flights[x][i].second ] = 1;
                   // cout << node2FlightsInv[x][i].second << " => " << node2Flights[y][j].second << '\n';
                }
            }
        }
    }

    for(int i = 0;i<t;i++)
    {
        int x = flights[i].second;
        for(int j = node2Flights[x].size()-1;j>=0;j--)
        {
            if(node2Flights[x][j].second<=i) break;
            flightGraph[i].push_back(node2Flights[x][j].second);
        }
    }

    for(int i = t-1;i>=0;i--)
    {
        //cout << " ---- " << i << '\n';

        dp[i] = 1;
        for(int j: flightGraph[i])
        {
            //cout << " -> " << j << '\n';
            dp[i] = max(dp[i], dp[j] + 1);
        }
    }

    int answer = 0;
    for(int i = 0;i<t;i++)
    {
        answer = max(answer, dp[i]);
    }

    cout << answer << '\n';
}
