#include<bits/stdc++.h>
using namespace std;

const int nmax=5e5+42;

int outp[nmax];

int n,q;

vector<int> adj[nmax];

char inp[nmax];

int up[20][nmax];

int level[nmax];

int SZ[nmax];

int pref_with_me[nmax],pref_without_me[nmax];

int heaviest[nmax];

void dfs(int node,int par,int h,int sum)
{
    pref_without_me[node]=sum;

    if(inp[node]=='+')sum++;
    else sum--;

    pref_with_me[node]=sum;

    level[node]=h;

    up[0][node]=par;

    for(int i=1;i<20;i++)up[i][node]=up[i-1][up[i-1][node]];

    SZ[node]=1;

    int which=0;

    for(auto k:adj[node])
        if(k!=par)
        {
            dfs(k,node,h+1,sum);
            SZ[node]+=SZ[k];

            if(SZ[k]>SZ[which])which=k;
        }
    heaviest[node]=which;
}

int lca(int u,int v)
{
    if(level[u]<level[v])swap(u,v);

    for(int i=19;i>=0;i--)
        if(level[u]-(1<<i)>=level[v])u=up[i][u];

    if(u==v)return u;

    for(int i=19;i>=0;i--)
        if(up[i][u]!=up[i][v])u=up[i][u],v=up[i][v];

    return up[0][u];
}

vector<int> paths[nmax],fenwick[nmax];

int which_path[nmax];

int pointer=1;

int where_in_path[nmax];

void fenwick_update(int which_path,int pos)
{
    while(pos<fenwick[which_path].size())
    {
        fenwick[which_path][pos]++;

        pos=pos+(pos&(-pos));
    }
}
void update(int node)
{
    fenwick_update(which_path[node],where_in_path[node]);
}

int exact(int where,int pos)
{
    int ret=0;

    while(pos)
    {
        ret+=fenwick[where][pos];
        pos=pos-(pos&(-pos));
    }
    return ret;
}
int fenwick_query(int where,int le,int ri)
{
    return exact(where,ri)-exact(where,le-1);
}
int query(int u,int l)
{
    int ret=0;

    while(which_path[u]!=which_path[l])
    {
        ret+=fenwick_query(which_path[u],1,where_in_path[u]);
        u=paths[which_path[u]][1];

        u=up[0][u];
    }

    ret+=fenwick_query(which_path[u],where_in_path[l],where_in_path[u]);

    return ret;
}
void dfs_paths(int node,int par)
{
    where_in_path[node]=paths[pointer].size();

    paths[pointer].push_back(node);
    which_path[node]=pointer;

    if(heaviest[node])
    {
        dfs_paths(heaviest[node],node);
    }

    for(auto k:adj[node])
        if(k!=par&&k!=heaviest[node])
        {
            pointer++;

            paths[pointer].push_back(-1);

            dfs_paths(k,node);
        }
}

pair<int,int> queries[nmax];

struct info
{
    int u,l,path,lower,upper,id;
};

info type_1[nmax],type_2[nmax];

bool cmp_1(info a,info b)
{
    return a.upper<b.upper;
}

bool cmp_2(info a,info b)
{
    return a.lower>b.lower;
}

vector< pair<int/*value*/,int/*id*/> > active;
void calc_type_1()
{
    for(int i=1;i<=pointer;i++)
    {
        fenwick[i]={};
        for(int j=0;j<=paths[i].size();j++)fenwick[i].push_back(0);
    }

    sort(type_1+1,type_1+q+1,cmp_1);

    active={};
    for(int i=1;i<=n;i++)
        active.push_back({pref_without_me[i],i});

    sort(active.begin(),active.end());

    int pointer_active=0;

    for(int i=1;i<=q;i++)
    {
        while(pointer_active<active.size()&&type_1[i].upper>active[pointer_active].first)
        {
            update(active[pointer_active].second);
            pointer_active++;
        }

        outp[type_1[i].id]+=query(type_1[i].u,type_1[i].l);
    }
}

bool cmp_active(pair<int/*value*/,int/*id*/> a,pair<int/*value*/,int/*id*/> b)
{
    return a.first>b.first;
}
void calc_type_2()
{
    for(int i=1;i<=pointer;i++)
    {
        fenwick[i]={};
        for(int j=0;j<=paths[i].size();j++)fenwick[i].push_back(0);
    }

    sort(type_2+1,type_2+q+1,cmp_2);

    active={};
    for(int i=1;i<=n;i++)
        active.push_back({pref_with_me[i],i});

    sort(active.begin(),active.end(),cmp_active);

    int pointer_active=0;

    for(int i=1;i<=q;i++)
    {
        while(pointer_active<active.size()&&type_2[i].lower<active[pointer_active].first)
        {
            update(active[pointer_active].second);
            pointer_active++;
        }

        outp[type_2[i].id]+=query(type_2[i].u,type_2[i].l);
    }
}

int main()
{
    paths[1].push_back(-1);

    scanf("%i%i",&n,&q);

    for(int i=1;i<=n;i++)
    {
        char c=getchar();
        while(c!='+'&&c!='-')c=getchar();
        inp[i]=c;
    }

    for(int i=1;i<n;i++)
    {
        int u,v;
        scanf("%i%i",&u,&v);

        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    dfs(1,1,0,0);
    /*
    for(int i=1;i<=n;i++)cout<<heaviest[i]<<" ";cout<<endl;
    */
    dfs_paths(1,1);
    /*
    for(int i=1;i<=pointer;i++)
    {
        cout<<i<<" -> ";for(auto k:paths[i])cout<<k<<" ";cout<<endl;
    }
    */

    for(int i=1;i<=q;i++)
    {
        int u,v;

        scanf("%i%i",&u,&v);

        queries[i].first=u;
        queries[i].second=v;

        int l=lca(u,v);

        if(pref_with_me[u]>pref_without_me[l])outp[i]--;

        type_1[i].u=u;
        type_1[i].l=l;
        type_1[i].upper=pref_with_me[u];
        type_1[i].id=i;

        type_2[i].u=v;
        type_2[i].l=l;
        type_2[i].lower=pref_with_me[l]+pref_without_me[l]-pref_with_me[u];
        type_2[i].id=i;
    }

    calc_type_1();

    calc_type_2();

    for(int i=1;i<=q;i++)
        printf("%i\n",outp[i]);

    return 0;
}
