#include <iostream>
using std::cin; using std::cout; using std::endl;

int sizeX, sizeY;
int matrix[500][500];

constexpr int dist(const int a, const int b) {
	return (a > b ? a-b : b-a);
}

struct StateField {
	int dp[10][500][500];
};

StateField* run() {
	StateField *sf = new StateField;

	for(int d = 0;d < 10;d ++) {
		// base case (1x1)
		sf->dp[d][0][0] = dist(d, matrix[0][0]);
		//cout << d << ' ' << sf.dp[d][0][0] << endl;

		// first column
		for(int y = 1;y < sizeY;y ++) {
			sf->dp[d][0][y] = sf->dp[d][0][y-1] + dist(d, matrix[0][y]);
		}

		// the rest of the matrix
		for(int x = 1;x < sizeX;x ++) {
			for(int y = 0;y < sizeY;y ++) {
				int up = (1 << 30), lf = (1 << 30);
				if(y > 0) up = sf->dp[d][x][y-1];
				lf = sf->dp[d][x-1][y];

				const int D = dist(d, matrix[x][y]);
				sf->dp[d][x][y] = std::min(up, lf) + D;
			}
		}
	}

	return sf;
}

int main() {
	std::cin.tie(nullptr);
	std::ios_base::sync_with_stdio(false);

	cin >> sizeY >> sizeX;
	for(int y = 0;y < sizeY;y ++) {
		for(int x = 0;x < sizeX;x ++) {
			char c; cin >> c;
			matrix[x][y] = c - '0';
		}
	}

	StateField *ul = run();

	/*
	for(int d = 0;d < 10;d ++) {
		cout << "best for D=" << d << endl;
		for(int y = 0;y < sizeY;y ++) {
			for(int x = 0;x < sizeX;x ++) {
				cout << ul->dp[d][x][y] << '\t';
			}
			cout << '\n';
		}
	}
	*/

	int ans = (1 << 30);
	for(int d = 0;d < 10;d ++) {
		int lastRow = (1 << 30), lastCol(1 << 30);
		for(int y = 0;y < sizeY;y ++) {
			lastCol = std::min(lastCol, ul->dp[d][sizeX-1][y]);
		}
		for(int x = 0;x < sizeX;x ++) {
			lastRow = std::min(lastRow, ul->dp[d][x][sizeY-1]);
		}
		ans = std::min(ans, std::min(lastRow + lastCol, ul->dp[d][sizeX-1][sizeY-1]));
	}
	cout << ans << endl;

	return 0;
}
