#include <iostream>
using std::cin; using std::cout; using std::endl;

int sizeX, sizeY;
int matrix[500][500];

constexpr int dist(const int a, const int b) {
	return (a > b ? a-b : b-a);
}

int dp_lr[10][500][500][2][2];
bool mem[10][500][500][2][2];

int calc_lr(int x, int y, int digit, bool up = true, bool down = true) {
	//cout << x << ' ' << y << ' ' << digit << ' ' << up << ' ' << down << endl;
	if(mem[digit][x][y][up][down]) return dp_lr[digit][x][y][up][down];

	int u = (1<<30), d = (1<<30), left = 0;
	int res = dist(digit, matrix[x][y]);

	if(x != 0) {
		left = calc_lr(x-1, y, digit, true, true);
		if(y - 1 >= 0 and up)      u = calc_lr(x, y-1, digit, up, false);
		if(y + 1 < sizeY and down) d = calc_lr(x, y+1, digit, false, down);

		res += std::min(std::min(u, d), left);
	}

	mem[digit][x][y][up][down] = true;
	dp_lr[digit][x][y][up][down] = res;
	return res;
}

int main() {
	std::cin.tie(nullptr);
	std::ios_base::sync_with_stdio(false);

	cin >> sizeY >> sizeX;
	for(int y = 0;y < sizeY;y ++) {
		for(int x = 0;x < sizeX;x ++) {
			char c; cin >> c;
			matrix[x][y] = c - '0';
		}
	}

	//cout << calc_lr(0, 0, 7) << ' ';
	/*
	for(int y = 0;y < sizeY;y ++) {
		for(int x = 0;x < sizeX;x ++) {
			cout << calc_lr(x, y, 8) << '\t';
		}
		cout << endl;
	}
	*/

	int ans = (1 << 30);
	for(int d = 0;d < 10;d ++) {
		for(int y = 0;y < sizeY;y ++) {
			ans = std::min(ans, calc_lr(sizeX-1, y, d));
		}
	}
	cout << ans << endl;

	return 0;
}
