#include <iostream>
#include <bitset>
using std::cin; using std::cout; using std::endl;

int sizeX, sizeY;
int matrix[500][500];

constexpr int dist(const int a, const int b) {
	return (a > b ? a-b : b-a);
}

int dp_lr[10][500][500][2][2];
char bt_lr[10][500][500];
bool mem_lr[10][500][500][2][2];
int calc_lr(int x, int y, int digit, bool up = true, bool down = true) {
	if(mem_lr[digit][x][y][up][down]) return dp_lr[digit][x][y][up][down];

	int u = (1<<30), d = (1<<30), left = 0;
	int res = dist(digit, matrix[x][y]);

#define B bt_lr[digit][x][y]
	if(x == 0) {
		 if(up and down) B = 'x';
	} else {
		left = calc_lr(x-1, y, digit, true, true);
		if(y - 1 >= 0 and up)      u = calc_lr(x, y-1, digit, up, false);
		if(y + 1 < sizeY and down) d = calc_lr(x, y+1, digit, false, down);

		const int M = std::min(std::min(u, d), left);
		if(up and down) {
			if(u == M) B = 'u';
			else if(d == M) B = 'd';
			else B = 'l';
		}

		res += M;
	}

	mem_lr[digit][x][y][up][down] = true;
	dp_lr[digit][x][y][up][down] = res;
	return res;
#undef B
}

int dp_ud[10][500][500][2][2];
char bt_ud[10][500][500];
bool mem_ud[10][500][500][2][2];
int calc_ud(int x, int y, int digit, bool left = true, bool right = true) {
	if(mem_ud[digit][x][y][left][right]) return dp_ud[digit][x][y][left][right];

	int l = (1<<30), r = (1<<30), up = 0;
	int res = dist(digit, matrix[x][y]);

#define B bt_ud[digit][x][y]
	if(y == 0) {
		 if(left and right) B = 'x';
	} else {
		up = calc_ud(x, y-1, digit, true, true);
		if(x - 1 >= 0 and left)     l = calc_ud(x-1, y, digit, left, false);
		if(x + 1 < sizeX and right) r = calc_ud(x+1, y, digit, false, right);

		const int M = std::min(std::min(l, r), up);
		if(left and right) {
			if(l == M) B = 'l';
			else if(r == M) B = 'r';
			else B = 'u';
		}

		res += M;
	}

	mem_ud[digit][x][y][left][right] = true;
	dp_ud[digit][x][y][left][right] = res;
	return res;
#undef B
}

char used[500][500];

void backtrack_lr(int x, int y, int digit) {
#define B bt_lr[digit][x][y]
	while(true) {
		used[x][y] |= 0b01;
		if(B == 'x') break;
		else if(B == 'u') y--;
		else if(B == 'd') y++;
		else if(B == 'l') x--;
	}
#undef B
}
void backtrack_ud(int x, int y, int digit) {
#define B bt_ud[digit][x][y]
	while(true) {
		used[x][y] |= 0b10;
		if(B == 'x') break;
		else if(B == 'l') x--;
		else if(B == 'r') x++;
		else if(B == 'u') y--;
	}
#undef B
}
void and_used(int mask) {
	for(int y = 0;y < sizeY;y ++) {
		for(int x = 0;x < sizeX;x ++) {
			used[x][y] &= mask;
		}
	}
}

int get_ans(int digit) {
	int ans = 0;
	for(int y = 0;y < sizeY;y ++) {
		for(int x = 0;x < sizeX;x ++) {
			if(used[x][y] != 0) ans += dist(digit, matrix[x][y]);
		}
	}
	return ans;
}

void print_used(int digit) {
	cout << "========= digit = " << digit << endl;
	for(int y = 0;y < sizeY;y ++) {
		for(int x = 0;x < sizeX;x ++) {
			cout << std::bitset<2>(used[x][y]) << ' ';
		}
		cout << endl;
	}
}

int main() {
	std::cin.tie(nullptr);
	std::ios_base::sync_with_stdio(false);

	cin >> sizeY >> sizeX;
	for(int y = 0;y < sizeY;y ++) {
		for(int x = 0;x < sizeX;x ++) {
			char c; cin >> c;
			matrix[x][y] = c - '0';
		}
	}

	//cout << calc_lr(0, 0, 7) << ' ';
	/*
	for(int y = 0;y < sizeY;y ++) {
		for(int x = 0;x < sizeX;x ++) {
			cout << calc_lr(x, y, 8) << '\t';
		}
		cout << endl;
	}
	*/
	int ans = (1 << 30);
	for(int d = 7;d <= 7;d ++) {
		// run dp
		for(int y = 0;y < sizeY;y ++) {
			for(int x = 0;x < sizeX;x ++) {
				calc_lr(x, y, d);
				calc_ud(x, y, d);
			}
		}

		// backtrack
		for(int y = 0;y < sizeY;y ++) {
			and_used(0b00); // clear
			backtrack_lr(sizeX-1, y, d);
			for(int x = 0;x < sizeX;x ++) {
				backtrack_ud(x, sizeY-1, d);
				ans = std::min(ans, get_ans(d));
				//if(ans == 10) print_used(d);
				and_used(0b01);
			}
		}

	}

	cout << ans << endl;

	return 0;
}
