#include <iostream>
#include <queue>
#include <vector>
using std::cin; using std::cout; using std::endl;

int N, Q;
std::string descr;
const int MAX_N = 5e5 + 10;
std::vector<int> graph[MAX_N];
int dist[MAX_N], cfrom[MAX_N];
int add[MAX_N];

int query(int from, int to) {
	// bfs

	std::fill(dist, dist + N, 0);
	std::fill(cfrom, cfrom + N, -1);

	std::queue<int> q;
	q.push(to);
	dist[to] = 1;
	cfrom[to] = -999;

	bool end = false;
	while(q.size() and !end) {
		int curr = q.front();
		q.pop();

		for(auto nei : graph[curr]) {
			if(dist[nei] == 0) {
				cfrom[nei] = curr;
				dist[nei] = dist[curr] + 1;
				q.push(nei);
				if(nei == from) {
					end = true;
					break;
				}
			}
		}
	}

	// backtrack
	int curr = from;
	//cout << "==== bt " << endl;
	int sc = 0, ans = 0;
	while(curr != -999) {
		sc += add[curr];
		ans += sc > 0;
		//cout << curr << ' ';
		curr = cfrom[curr];
	}

	return ans;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	cin >> N >> Q;
	cin >> descr;
	for(int i = 0;i < N;i ++) {
		add[i+1] = descr[i] == '+' ? 1 : -1;
	}

	for(int i = 0;i < N-1;i ++) {
		int a, b;
		cin >> a >> b;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}

	for(int i = 0;i < Q;i ++) {
		int a, b;
		cin >> a >> b;
		cout << query(a, b) << '\n';
	}

	return 0;
}
