#include <iostream>
#include <queue>
#include <vector>
#include <map>
using std::cin; using std::cout; using std::endl;

int N, Q;
const int MAX_N = 5e5 + 10;

const int BS = 3;

class Historgram {
public:
	int cnt[MAX_N * 2];
	int last_sc = 0;
	int biggest = -(1<<30);
	int smallest = 1<<30;
	void add(int sc) {
		cnt[sc + MAX_N] ++;
		last_sc = sc;
		biggest = std::max(biggest, sc);
		smallest = std::min(smallest, sc);
	}
	int cnt_bigger_or_eq_than(int x) {
		int ans = 0;
		for(int i = x;i <= biggest;i ++) {
			ans += cnt[i + MAX_N];
		}
		return ans;
	}
};
Historgram buckets[2][BS + 10];


std::pair<int, int> apply_manual(int el_idx_from, int el_idx_to, std::string &descr, int sc) {
	int count = 0;
	for(int i = el_idx_from;i < el_idx_to;i ++) {
		if(descr[i] == '+') sc ++;
		else sc --;
		if(sc > 0) count ++;
	}
	return {sc, count};
}

template<int T>
int query(int from, int to, std::string &descr) {
	int bfrom = from / BS;
	int bto = to / BS;

	//cout << "query " << from << ' ' << to << endl;
	int ans = 0;
	if(bfrom == bto or bfrom + 1 == bto) {
		auto _ = apply_manual(from, to+1, descr, 0);
		ans = _.second;
	} else {
		auto _b = apply_manual(from, (bfrom+1) * BS, descr, 0);
		int sc = _b.first;
		ans += _b.second;

		for(int i = bfrom + 1;i <= bto-1;i ++) {
			ans += buckets[T][i].cnt_bigger_or_eq_than(-sc);
			sc += buckets[T][i].last_sc;
		}

		auto _e = apply_manual(bto * BS, bto, descr, sc);
		ans += _e.second;
	}
	//cout << from << ' ' << S << endl;
	return ans;
}

template<int T>
void calc_bucket(int el_idx_from, int el_idx_to, int b_idx, std::string &descr) {
	//cout << "calc_bucket " << el_idx_from << ' ' << el_idx_to << ' ' << b_idx << endl;
	int sc = 0;
	for(int i = el_idx_from;i < el_idx_to;i ++) {
		if(descr[i] == '+') sc ++;
		else sc --;
		buckets[T][b_idx].add(sc);
	}
}

template<int T>
void bucketize(std::string descr) {
	for(int i = 0;;i ++) {
		if(i * BS >= N) break;
		calc_bucket<T>(i * BS, std::min((i+1)*BS, N), i, descr);
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	cin >> N >> Q;
	std::string descr;
	cin >> descr;

	// spam
	for(int i = 0;i < N-1;i ++) {
		int a, b;
		cin >> a >> b;
	}

	std::string rev;
	for(int i = descr.size()-1;i >= 0;i --) rev += descr[i];

	bucketize<0>(descr);
	bucketize<1>(rev);


	for(int i = 0;i < Q;i ++) {
		int a, b;
		cin >> a >> b;
		a --;
		b --;
		if(a <= b) {
			cout << query<0>(a, b, descr) << '\n';
		} else {
			cout << query<1>(rev.size() - a - 1, rev.size() - b - 1, rev) << '\n';
		}
	}

	return 0;
}
