#include <iostream>
#include <vector>
using std::cin; using std::cout; using std::endl;

int N, M, T;
const int MAX_N = 5e5 + 10;
const int MAX_T = 5e5 + 10;
std::vector<int> graph[MAX_N];
std::pair<int, int> plane[MAX_T];

bool bus(int from, int to) {
	if(from == to) return true;
	for(auto x : graph[from]) {
		if(x == to) return true;
	}
	return false;
}

int prev_best[MAX_N], new_best[MAX_N];

int main() {
	std::cin.tie(nullptr);
	std::ios_base::sync_with_stdio(false);

	cin >> N >> M >> T;
	for(int i = 0;i < N;i ++) {
		int cnt; cin >> cnt;
		graph[i].resize(cnt);
		for(int j = 0;j < cnt;j ++) {
			cin >> graph[i][j];
		}
	}

	for(int i = 0;i < T;i ++) {
		cin >> plane[i].first >> plane[i].second;
	}

	// g0
	std::fill(prev_best, prev_best + N, 0);
	std::fill(new_best, new_best + N, 0);

	for(int t = 1;t <= T;t ++) {
		auto P = plane[t-1];

		for(int i = 0;i < N;i ++) {
			if(bus(i, P.first)) {
				//cout << "try " << i << ' ' << P.first << endl;
				new_best[P.second] = std::max(new_best[P.second], prev_best[i] + 1);
			}
		}

		/*
		cout << "====== T=" << t << endl;
		for(int i = 0;i < N;i ++) { cout << i << ')' << prev_best[i] << '\t'; }
		cout << endl;
		for(int i = 0;i < N;i ++) { cout << i << ')' << new_best[i] << '\t'; }
		cout << endl;
		*/

		std::copy(new_best, new_best + N, prev_best);
	}

	int ans = 0;
	for(int i = 0;i < N;i ++) ans = std::max(ans, prev_best[i]);
	cout << ans << endl;

	return 0;
}
