#include <iostream>
#include <vector>
using std::cin; using std::cout; using std::endl;

int N, M, T;
const int MAX_N = 5e5 + 10;
const int MAX_T = 5e5 + 10;
std::vector<int> graph[MAX_N];
std::pair<int, int> plane[MAX_T];

bool bus(int from, int to) {
	if(from == to) return true;
	for(auto x : graph[from]) {
		if(x == to) return true;
	}
	return false;
}

int best[2][MAX_N];

int main() {
	std::cin.tie(nullptr);
	std::ios_base::sync_with_stdio(false);

	cin >> N >> M >> T;
	for(int i = 0;i < N;i ++) {
		int cnt; cin >> cnt;
		graph[i].resize(cnt);
		for(int j = 0;j < cnt;j ++) {
			cin >> graph[i][j];
		}
	}

	for(int i = 0;i < T;i ++) {
		cin >> plane[i].first >> plane[i].second;
	}

	for(int t = 1;t <= T;t ++) {
		auto P = plane[t-1];
		const int tp1 = t+1;

		/*
		for(int i = 0;i < N;i ++) {
			best[t&1][i] = std::max(best[t&1][i], best[tp1&1][i]);
		}
		*/
		std::copy(best[tp1&1], best[tp1&1] + N, best[t&1]);

		best[t&1][P.second] = std::max(best[t&1][P.second], best[tp1&1][P.first] + 1);
		for(auto x : graph[P.first]) {
			best[t&1][P.second] = std::max(best[t&1][P.second], best[tp1&1][x] + 1);
		}

		/*
		cout << "====== T=" << t << endl;
		for(int i = 0;i < N;i ++) { cout << i << ')' << best[tp1&1][i] << '\t'; }
		cout << endl;
		for(int i = 0;i < N;i ++) { cout << i << ')' << best[t&1][i] << '\t'; }
		cout << endl;
		*/

		//std::copy(new_best, new_best + N, prev_best);
	}

	int ans = 0;
	for(int i = 0;i < N;i ++) ans = std::max(ans, best[T&1][i]);
	cout << ans << endl;

	return 0;
}
