#include<iostream>
#include<queue>
using namespace std;
const int maxn = 600;
int n, m;
int g[maxn][maxn];
int g2[maxn][maxn];
bool vis[maxn][maxn];

int mincol[maxn][maxn];
int minrow[maxn][maxn];

pair<int,int> from[maxn][maxn];

int dir[4][2] = {{+1,0},{-1,0},{0,+1},{0,-1}};

const int inf = 1e8;

void fnd(bool col)
{
    priority_queue<pair<int,pair<pair<int,int>, pair<int,int> > > > q;
    if(col)
    {
        for(int i = 0; i < n; i ++)
        {
            q.push({-g2[i][0], {{i,0}, {-2,-2}} });
        }
    } else {
        for(int i = 0; i < m; i ++)
        {
            q.push({-g2[0][i], {{0,i}, {-2,-2}} });
        }
    }
    for(int i = 0; i < n; i ++)
    {
        for(int j = 0; j < m; j ++)
        {
            vis[i][j] = false;
            from[i][j] = {-1,-1};
            if(col)
            {
                mincol[i][j] = inf;
            } else {
                minrow[i][j] = inf;
            }
        }
    }

    while(!q.empty())
    {
        auto curr = q.top();
        q.pop();
        int x = curr.second.first.first, y = curr.second.first.second;
        int fx = curr.second.second.first, fy = curr.second.second.second;
        int d = curr.first;
        if(vis[x][y])   continue;
        vis[x][y] = true;
        from[x][y] = curr.second.second;

        if((col && y == m - 1) || (!col && x == n - 1))
        {
            pair<int,int> t = {x,y};
            while(t.first != -2)
            {
                if(col)
                {
                    mincol[t.first][t.second] = min(mincol[t.first][t.second], -d);
                } else {
                    minrow[t.first][t.second] = min(minrow[t.first][t.second], -d);
                }
                t = from[t.first][t.second];
            }
        }

        for(int i = 0; i < 4; i ++)
        {
            int x2 = x + dir[i][0], y2 = y + dir[i][1];
            if(x2 < 0 || y2 < 0 || x2 >= n || y2 >= m || vis[x2][y2])   continue;
            q.push({d - g2[x2][y2], {{x2, y2}, {x, y}}});
        }
    }
    return;
}

int main()
{
    cin >> n >> m;
    for(int i = 0; i < n; i ++)
    {
        for(int j = 0; j < m; j ++)
        {
            char c;
            cin >> c;
            g[i][j] = c - '0';
        }
    }
    int ans = inf;
    for(int i = 0; i < 10; i ++)
    {
        for(int x = 0; x < n; x ++)
        {
            for(int y = 0; y < m; y ++)
            {
                g2[x][y] = abs(g[x][y] - i);
            }
        }
        fnd(true);
        fnd(false);

        /*for(int x = 0; x < n; x ++)
        {
            for(int y = 0; y < m; y ++)
            {
                cout << g2[x][y];
            }
            cout << endl;
        }
        cout << endl;
        for(int x = 0; x < n; x ++)
        {
            for(int y = 0; y < m; y ++)
            {
                cout << mincol[x][y] << " ";
            }
            cout << endl;
        }
        cout << endl;
        for(int x = 0; x < n; x ++)
        {
            for(int y = 0; y < m; y ++)
            {
                cout << minrow[x][y] << " ";
            }
            cout << endl;
        }
        cout << endl;

        cout << "\n====================\n";*/

        int ta = inf;

        for(int x = 0; x < n; x ++)
        {
            for(int y = 0; y < n; y ++)
            {
                ta = min(ta, mincol[x][y] + minrow[x][y] - g2[x][y]);
            }
        }
        ans = min(ans, ta);
    }
    cout << ans;

}
/**
5 5
3 3 2 3 3
3 3 2 3 3
2 2 2 2 2
3 3 2 3 3
3 3 2 3 3
*/
