#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#pragma GCC optimization("O3")

#define pb push_back
#define fr first
#define sc second
#define ll long long
#define ld long double
#define bit(x) x&(-x)
#define bin(x, a) bitset<a>(x)
#define all(x) x.begin(), x.end()
#define de(x) cout << #x << " = " << x << endl;
#define matrix vector<vector<ll>>
#define row vector<ll>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
/// find_by_order(x) -> x-th element in the set
/// order_of_key(x)  -> how many elements are smaller than x

const int MAXN = 5e5 + 5;
const int MAXLOG = 22;

ll n, q, up[MAXN][MAXLOG], timer, tin[MAXN], tout[MAXN];
string t;
matrix G;

void generate_lca(ll u, ll p){
    tin[u] = timer;
    ++ timer;

    up[u][0] = p;
    for(int i = 1; i < MAXLOG; i ++){
        up[u][i] = up[up[u][i - 1]][i - 1];
    }
    for(auto v : G[u]){
        if(v != p){
            generate_lca(v, u);
        }
    }

    tout[u] = timer;
    ++ timer;
}

bool isancestor(ll u, ll v){
    return (tin[u] <= tin[v] && tout[u] >= tout[v]);
}

ll lca(ll u, ll v){
    if(isancestor(u, v)){
        return u;
    }
    else if(isancestor(v, u)){
        return v;
    }
    else{
        for(int i = 0; i < MAXLOG; i ++){
            if(!isancestor(up[u][i], v)){
                u = up[u][i];
            }
        }
        return up[u][0];
    }
}

int main(){
    ios_base::sync_with_stdio(NULL); cin.tie(0); cout.tie(0);
    cin >> n >> q >> t; t = '#' + t;
    G = matrix(n + 1);
    for(int i = 0; i < n - 1; i ++){
        ll u, v; cin >> u >> v;
        G[u].pb(v);
        G[v].pb(u);
    }
    generate_lca(1, 1);
    for(int i = 0; i < q; i ++){
        string tmp1, tmp2;
        ll U, V; cin >> U >> V;
        ll LCA = lca(U, V);
        while(U != LCA){
            tmp1 += t[U];
            U = up[U][0];
        }
        while(V != LCA){
            tmp2 += t[V];
            V = up[V][0];
        }
        reverse(all(tmp2));
        string tmp = tmp1 + t[LCA] + tmp2;
        ll inter = 0, ans = 0;
        for(int i = 0; i < tmp.size(); i ++){
            inter += (tmp[i] == '+' ? +1 : -1);
            if(inter > 0){
                ++ ans;
            }
        }
        cout << ans << endl;
    }
}
/**
8 5
-+++-++-
1 5
5 6
3 6
4 5
4 7
4 8
1 2
3 8
2 2
1 7
2 7
6 4

6 4
+-++--
1 2
2 3
3 4
4 5
5 6
1 6
6 1
5 1
2 4
*/
