#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 503;

int n, m;
int a[maxn][maxn];
void read()
{
    cin >> n >> m;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        {
            char ch;
            cin >> ch;
            a[i][j] = ch - '0';
        }
}

int dist[10][4][maxn][maxn];
vector <pair <int, int> > adj[maxn][maxn];
void dijkstra(int dig, int from)
{
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        dist[dig][from][i][j] = INT_MAX;

    priority_queue <pair <int, pair <int, int> > > q;
    if (from == 0)
        for (int i = 1; i <= m; i++)
        {
            dist[dig][from][1][i] = abs(a[1][i] - dig);
            q.push({-abs(a[1][i] - dig), {1, i}});
        }

    else
        if (from == 1)
        for (int i = 1; i <= n; i++)
    {
        dist[dig][from][i][m] = abs(a[i][m] - dig);
        q.push({-abs(a[i][m] - dig), {i, m}});
    }


    else
        if (from == 2)
        for (int i = 1; i <= m; i++)
    {
        dist[dig][from][n][i] = abs(a[n][i] - dig);
        q.push({-abs(a[n][i] - dig), {n, i}});
    }

    else
        for (int i = 1; i <= n; i++)
    {
        dist[dig][from][i][1] = abs(a[i][1] - dig);
        q.push({-abs(a[i][1] - dig), {i, 1}});
    }

    while (!q.empty())
    {
        auto ver = q.top();
        q.pop();

        if (-ver.first != dist[dig][from][ver.second.first][ver.second.second])
            continue;

        for (auto i: adj[ver.second.first][ver.second.second])
        {
            int curr_cost = -ver.first + abs(a[i.first][i.second] - dig);
            if (curr_cost < dist[dig][from][i.first][i.second])
            {
                dist[dig][from][i.first][i.second] = curr_cost;
                q.push({-curr_cost, {i.first, i.second}});
            }
        }
    }
}

void solve()
{
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
    {
        if (i != 1)
        adj[i][j].push_back({i-1, j});

        if (i != n)
        adj[i][j].push_back({i+1, j});

        if (j != 1)
        adj[i][j].push_back({i, j-1});

        if (j != m)
        adj[i][j].push_back({i, j+1});
    }

    for (int i = 0; i <= 9; i++)
    for (int j = 0; j <= 3; j++)
        dijkstra(i, j);

    int ans = INT_MAX;

    for (int dig = 0; dig <= 9; dig++)
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
        {
            int sum = 0, min1 = INT_MAX, min2 = INT_MAX, min3 = INT_MAX, min4 = INT_MAX;
            for (int k = j; k <= m; k++)
            {
                min1 = min(min1, dist[dig][0][i][k]);
                min2 = min(min2, dist[dig][2][i][k]);
                min3 = min(min3, dist[dig][1][i][k]);
                min4 = min(min4, dist[dig][3][i][k]);
                sum += abs(a[i][k] - dig);
                ans = min(ans, min1 + min2 + min3 + min4 + sum);
            }
        }
    }

    for (int dig = 0; dig <= 9; dig++)
    for (int i = 1; i <= m; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            int sum = 0, min1 = INT_MAX, min2 = INT_MAX, min3 = INT_MAX, min4 = INT_MAX;
            for (int k = j; k <= n; k++)
            {
                min1 = min(min1, dist[dig][0][k][i]);
                min2 = min(min2, dist[dig][2][k][i]);
                min3 = min(min3, dist[dig][1][k][i]);
                min4 = min(min4, dist[dig][3][k][i]);
                sum += abs(a[k][i] - dig);
                ans = min(ans, min1 + min2 + min3 + min4 + sum);
            }
        }
    }

    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
