#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")

using namespace std;

const int maxn = 503;

int n, m;
int a[maxn][maxn];
void read()
{
    cin >> n >> m;
    for (int i = 1; i <= n; i++)
    {
        string s;
        cin >> s;

        for (int j = 0; j < m; j++)
            a[i][j+1] = s[j] - '0';
    }
}

int ans = INT_MAX;
int pdist[2][maxn][maxn];
vector <pair <int, int> > adj[maxn][maxn];
int b[maxn][maxn];
void pdijkstra(int dig, bool from)
{
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        b[i][j] = abs(a[i][j] - dig);

    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        pdist[from][i][j] = INT_MAX;

    priority_queue <pair <int, pair <int, int> > > q;
    if (!from)
        for (int i = 1; i <= m; i++)
        {
            pdist[from][1][i] = b[1][i];
            q.push({-b[1][i], {1, i}});
        }

    else
        for (int i = 1; i <= m; i++)
    {
        pdist[from][n][i] = b[n][i];
        q.push({-b[n][i], {n, i}});
    }

    while (!q.empty())
    {
        auto ver = q.top();
        q.pop();

        if (-ver.first != pdist[from][ver.second.first][ver.second.second])
            continue;

        for (auto i: adj[ver.second.first][ver.second.second])
        {
            int curr_cost = -ver.first + b[i.first][i.second];
            if (curr_cost < pdist[from][i.first][i.second])
            {
                pdist[from][i.first][i.second] = curr_cost;
                q.push({-curr_cost, {i.first, i.second}});
            }
        }
    }
}

struct state
{
    int dist, x, y;
    bool is1, is2;
    bool operator < (const state &t) const
    {
        return dist > t.dist;
    }
};

int dist[maxn][maxn][2][2];
void dijkstra(int dig)
{
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        b[i][j] = abs(a[i][j] - dig);

    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        for (int k = 0; k <= 1; k++)
        for (int p = 0; p <= 1; p++)
        dist[i][j][k][p] = INT_MAX;

    priority_queue <state> q;
    for (int i = 1; i <= n; i++)
    for (int j = 0; j <= 1; j++)
        for (int k = 0; k <= 1; k++)
    {
        dist[i][1][j][k] = b[i][1];
        if (j == 1)
            dist[i][1][j][k] += pdist[0][i][1] - b[i][1];

        if (k == 1)
        dist[i][1][j][k] += pdist[1][i][1] - b[i][1];

        q.push({dist[i][1][j][k], i, 1, j, k});
    }

    while (!q.empty())
    {
        auto ver = q.top();
        q.pop();

        if (ver.dist >= ans)
            break;

        if (ver.dist != dist[ver.x][ver.y][ver.is1][ver.is2])
            continue;

        if (ver.y == m && ver.is1 && ver.is2)
        {
            ans = min(ans, ver.dist);
            break;
        }

        for (auto i: adj[ver.x][ver.y])
        for (int j = ver.is1; j <= 1; j++)
        for (int k = ver.is2; k <= 1; k++)
        {
            int curr_dist = ver.dist + b[i.first][i.second];
            if (j != ver.is1)
                curr_dist += pdist[0][i.first][i.second] - b[i.first][i.second];

            if (k != ver.is2)
                curr_dist += pdist[1][i.first][i.second] - b[i.first][i.second];

            if (curr_dist < dist[i.first][i.second][j][k])
            {
                dist[i.first][i.second][j][k] = curr_dist;
                q.push({curr_dist, i.first, i.second, j, k});
            }
        }
    }
}

int cnt[10];
void solve()
{
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
    {
        if (i != 1)
        adj[i][j].push_back({i-1, j});

        if (i != n)
        adj[i][j].push_back({i+1, j});

        if (j != 1)
        adj[i][j].push_back({i, j-1});

        if (j != m)
        adj[i][j].push_back({i, j+1});
    }

    for (int i = 1; i <= n; i++)
            for (int j = 1; j <= m; j++)
            cnt[a[i][j]]++;

    vector <pair <int, int> > v;
    for (int i = 0; i <= 9; i++)
    v.push_back({cnt[i], i});

    sort (v.begin(), v.end());
    reverse(v.begin(), v.end());


    if (n <= 200 && m <= 200)
    for (auto i: v)
    {
        pdijkstra(i.second, 0);
        pdijkstra(i.second, 1);
        dijkstra(i.second);
    }

        else
            for (int i = 0; i < 5; i++)
            {
                pdijkstra(v[i].second, 0);
                pdijkstra(v[i].second, 1);
                dijkstra(v[i].second);
            }

    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
