#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 5e5 + 3;
const int maxlog = 21;

int n, q;
int val[maxn];
vector <int> adj[maxn];
void read()
{
    cin >> n >> q;
    for (int i = 1; i <= n; i++)
    {
        char ch;
        cin >> ch;

        if (ch == '+')
            val[i] = 1;

        else
            val[i] = -1;
    }

    for (int i = 1; i <= n-1; i++)
    {
        int a, b;
        cin >> a >> b;

        adj[a].push_back(b);
        adj[b].push_back(a);
    }
}

int p[maxn], sz[maxn], par[maxn][maxlog];
void pre_dfs(int ver)
{
    sz[ver] = 1;
    for (auto i: adj[ver])
        if (i != par[ver][0])
    {
        p[i] = p[ver] + val[i];
        par[i][0] = ver;
        pre_dfs(i);

        sz[ver] += sz[i];
    }
}

void precompute()
{
    for (int i = 1; i <= 20; i++)
        for (int j = 1; j <= n; j++)
        par[j][i] = par[par[j][i-1]][i-1];
}

vector <int> order;
int head[maxn], pos[maxn];
void dfs2(int ver, int curr_head)
{
    order.push_back(ver);
    pos[ver] = (int)order.size() - 1;
    head[ver] = curr_head;

    int max_sz = -1, big_child = -1;
    for (auto i: adj[ver])
        if (i != par[ver][0])
        if (sz[i] > max_sz)
            max_sz = sz[i], big_child = i;

    if (big_child != -1)
    dfs2(big_child, curr_head);

    for (auto i: adj[ver])
        if (i != par[ver][0])
        if (i != big_child)
        dfs2(i, i);
}

bool is_inside(int a, int b)
{
    int l = pos[a], r = pos[a] + sz[a] - 1;
    if (l <= pos[b] && pos[b] <= r)
        return true;

    return false;
}

int lca(int a, int b)
{
    if (is_inside(a, b))
        return a;

    if (is_inside(b, a))
        return b;

    for (int i = 20; i >= 0; i--)
        if (par[a][i] && !is_inside(par[a][i], b))
        a = par[a][i];

    return par[a][0];
}

struct query
{
    int l, r, x, idx;
};

vector <query> v1, v2;
void find_queries(int a, int b, int idx)
{
    int c = lca(a, b);
    int curr = a;
    while (head[curr] != head[c])
    {
        int curr_head = head[curr];
        v1.push_back({pos[curr_head], pos[curr], p[a] - 1, idx});
        curr = par[curr_head][0];
    }

    v1.push_back({pos[c], pos[curr], p[a] - 1, idx});

    int sum = p[a] - p[c] + val[c];
    curr = b;
    while (head[curr] != head[c])
    {
        int curr_head = head[curr];
        v2.push_back({pos[curr_head], pos[curr], p[c] - sum + 1, idx});
        curr = par[curr_head][0];
    }

    if (curr != c)
        v2.push_back({pos[c] + 1, pos[curr], p[c] - sum + 1, idx});
}

int tr[maxn];
void update(int pos, int val)
{
    for (pos; pos <= n; pos += pos & -pos)
        tr[pos] += val;
}

int get_prefix(int pos)
{
    if (pos < 1)
        return 0;

    int ans = 0;
    for (pos; pos >= 1; pos -= pos & -pos)
        ans += tr[pos];

    return ans;
}

int get(int l, int r)
{
    return get_prefix(r) - get_prefix(l-1);
}

bool cmp1(query a, query b)
{
    if (a.x != b.x)
    return a.x < b.x;

    return a.idx < b.idx;
}

bool cmp2(query a, query b)
{
    if (a.x != b.x)
    return a.x > b.x;

    return a.idx < b.idx;
}

int ans[maxn];
void solve()
{
    p[1] = val[1];
    pre_dfs(1);
    precompute();
    dfs2(1, 1);

    for (int i = 1; i <= q; i++)
    {
        int a, b;
        cin >> a >> b;

        find_queries(a, b, i);
    }

    for (int i = 1; i <= n; i++)
    v1.push_back({i, -1, p[order[i-1]] - val[order[i-1]], -1});

    sort (v1.begin(), v1.end(), cmp1);
    for (auto i: v1)
    {
        if (i.idx == -1)
            update(i.l, 1);

        else
            ans[i.idx] += get(i.l + 1, i.r + 1);
    }

    memset(tr, 0, sizeof(tr));

    for (int i = 1; i <= n; i++)
    v2.push_back({i, -1, p[order[i-1]], -1});

    sort (v2.begin(), v2.end(), cmp2);
    for (auto i: v2)
    {
        if (i.idx == -1)
            update(i.l, 1);

        else
            ans[i.idx] += get(i.l + 1, i.r + 1);
    }

    for (int i = 1; i <= q; i++)
        cout << ans[i] << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
