#include <bits/stdc++.h>
using namespace std;
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")
#define endl "\n"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) {return x < y ? x = y, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) {return x > y ? x = y, 1 : 0;}
const ll mod = 1e9 + 7;

const int MAX_W  = 501, OFF = MAX_W * MAX_W;
const int MAX_N = 6 * MAX_W * MAX_W;

int tab[MAX_W][MAX_W], n, m;
pair<int, int> decode(int x) {
    return {x / m, x % m};
}

struct Edge {
    int from, to, flow, cap;
    Edge() {}
    Edge(int x, int y, int z, int w) {
        from = x;
        to = y;
        flow = z;
        cap = w;
    }
};

struct FlowNetwork {
    vector<Edge> edges;
    int level[MAX_N], ptr[MAX_N];
    vector<int> g[MAX_N];
    void addEdge(int a, int b, int cap) {
        g[a].push_back(edges.size());
        edges.push_back({a, b, 0, cap});
        g[b].push_back(edges.size());
        edges.push_back({b, a, 0, 0});
    }
    bool bfs(int s, int t) {
        fill_n(level, MAX_N, -1);
        level[s] = 0;
        queue<int> q;
        q.push(s);
        while(!q.empty()) {
            auto curr = q.front(); q.pop();
            for(auto &it : g[curr]) {
                if(level[edges[it].to] == -1 && edges[it].flow < edges[it].cap) {
                    level[edges[it].to] = level[curr] + 1;
                    q.push(edges[it].to);
                }
            }
        }
        return level[t] != -1;
    }
    int dfs(int s, int t, int flow) {
        if(s == t) {return flow;}
        for(; ptr[s] < g[s].size();) {
            auto curr = g[s][ptr[s]]; ptr[s] ++;
            if(level[s] + 1 != level[edges[curr].to] || edges[curr].flow >= edges[curr].cap) {continue;}
            int now = dfs(edges[curr].to, t, min(flow, edges[curr].cap - edges[curr].flow));
            if(now > 0) {
                edges[curr].flow += now;
                edges[curr ^ 1].flow -= now;
                return now;
            }
        }
        return 0;
    }
    int maxFlow(int s, int t) {
        int ret = 0;
        while(bfs(s, t)) {
            fill_n(ptr, MAX_N, 0);
            int f;
            while(f = dfs(s, t, mod)) {
                ret += f;
            }
        }
        return ret;
        for(auto it : edges) {
            if(it.flow == it.cap && it.cap > 0) {
                cout << decode(it.from % OFF).first << " " << decode(it.from % OFF).second << " " << it.cap << endl;
            }
        }
        return ret;
    }
    void reset() {
        for(int i = 0; i < MAX_N; i ++) {
            g[i].clear();
        }
        edges.clear();
    }
};

FlowNetwork fn;

int encode(int x, int y) {
    return x * m + y;
}

signed main() {//
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n >> m;
    for(int i = 0; i < n; i ++) {
        string in;
        cin >> in;
        for(int j = 0; j < m; j ++) {
            tab[i][j] = in[j] - '0';
        }
    }
    int ans = mod;
    int s = MAX_N - 11;
    int t = MAX_N - 10;
    for(int c = 0; c < 10; c ++) {
        fn.reset();
        for(int i = 0; i < n; i ++) {
            for(int j = 0; j < m; j ++) {
                int curr = i * m + j;
                for(int offset = 0; offset < 2; offset ++) {
                    fn.addEdge(offset * OFF + curr, 2 * OFF + curr, mod);
                    fn.addEdge(2 * OFF + curr + n * m, offset * OFF + curr + n * m, mod);
                    if(i > 0) {
                        fn.addEdge(offset * OFF + encode(i - 1, j) + n * m, offset * OFF + curr, mod); ///Otherout to currin;
                        fn.addEdge(offset * OFF + curr + n * m, offset * OFF + encode(i - 1, j), mod); ///Otherout to currin;
                    }
                    if(j > 0) {
                        fn.addEdge(offset * OFF + encode(i, j - 1) + n * m, offset * OFF + curr, mod); ///Otherout to currin;
                        fn.addEdge(offset * OFF + curr + n * m, offset * OFF + encode(i, j - 1), mod); ///Otherout to currin;
                    }
                    if(i < n - 1) {
                        fn.addEdge(offset * OFF + encode(i + 1, j) + n * m, offset * OFF + curr, mod); ///Otherout to currin;
                        fn.addEdge(offset * OFF + curr + n * m, offset * OFF + encode(i + 1, j), mod); ///Otherout to currin;
                    }
                    if(j < m - 1) {
                        fn.addEdge(offset * OFF + encode(i, j + 1) + n * m, offset * OFF + curr, mod); ///Otherout to currin;
                        fn.addEdge(offset * OFF + curr + n * m, offset * OFF + encode(i, j + 1), mod); ///Otherout to currin;
                    }
                    if(i > 0 && j > 0) {
                        fn.addEdge(offset * OFF + encode(i - 1, j - 1) + n * m, offset * OFF + curr, mod); ///Otherout to currin;
                        fn.addEdge(offset * OFF + curr + n * m, offset * OFF + encode(i - 1, j - 1), mod); ///Otherout to currin;
                    }
                    if(i < n - 1 && j > 0) {
                        fn.addEdge(offset * OFF + encode(i + 1, j - 1) + n * m, offset * OFF + curr, mod); ///Otherout to currin;
                        fn.addEdge(offset * OFF + curr + n * m, offset * OFF + encode(i + 1, j - 1), mod); ///Otherout to currin;
                    }
                    if(i > 0 && j < m - 1) {
                        fn.addEdge(offset * OFF + encode(i - 1, j + 1) + n * m, offset * OFF + curr, mod); ///Otherout to currin;
                        fn.addEdge(offset * OFF + curr + n * m, offset * OFF + encode(i - 1, j + 1), mod); ///Otherout to currin;
                    }
                    if(i < n - 1 && j < m - 1) {
                        fn.addEdge(offset * OFF + encode(i + 1, j + 1) + n * m, offset * OFF + curr, mod); ///Otherout to currin;
                        fn.addEdge(offset * OFF + curr + n * m, offset * OFF + encode(i + 1, j + 1), mod); ///Otherout to currin;
                    }
                }
                fn.addEdge(2 * OFF + curr, 2 * OFF + curr + n * m, abs(c - tab[i][j]));
            }
        }
        for(int i = 0; i < n; i ++) {
            fn.addEdge(s, 0 * OFF + encode(i, 0), mod);
            fn.addEdge(0 * OFF + encode(i, m - 1) + n * m, t, mod);
        }
        for(int i = 0; i < m; i ++) {
            fn.addEdge(s, 1 * OFF + encode(0, i), mod);
            fn.addEdge(1 * OFF + encode(n - 1, i) + n * m, t, mod);
        }
        chkmin(ans, fn.maxFlow(s, t));
        continue;
        fn.addEdge(s, 0 * OFF + encode(0, 0), mod);
        fn.addEdge(0 * OFF + encode(n - 1, 0) + n * m, t, mod);
        fn.addEdge(0 * OFF + encode(n - 1, m - 1) + n * m, t, mod);
        fn.addEdge(0 * OFF + encode(0, m - 1) + n * m, t, mod);

        fn.addEdge(1 * OFF + encode(0, 0) + n * m, t, mod);
        fn.addEdge(s, 1 * OFF + encode(n - 1, 0), mod);
        fn.addEdge(1 * OFF + encode(n - 1, m - 1) + n * m, t, mod);
        fn.addEdge(1 * OFF + encode(0, m - 1) + n * m, t, mod);

        fn.addEdge(2 * OFF + encode(0, 0) + n * m, t, mod);
        fn.addEdge(2 * OFF + encode(n - 1, 0) + n * m, t, mod);
        fn.addEdge(s, 2 * OFF + encode(n - 1, m - 1), mod);
        fn.addEdge(2 * OFF + encode(0, m - 1) + n * m, t, mod);

        fn.addEdge(3 * OFF + encode(0, 0) + n * m, t, mod);
        fn.addEdge(3 * OFF + encode(n - 1, 0) + n * m, t, mod);
        fn.addEdge(3 * OFF + encode(n - 1, m - 1) + n * m, t, mod);
        fn.addEdge(s, 3 * OFF + encode(0, m - 1), mod);
        chkmin(ans, fn.maxFlow(s, t));
    }
    cout << ans << endl;
    return 0;
}

/*
4 7
2753852
9567342
5294979
3180559
*/
