#include <bits/stdc++.h>

using namespace std;

const int MAXN = 505;

int n, m;
string a[MAXN];

void read_input()
{
	cin >> n >> m;

	for(int i = 0; i < n; i++)
	{
		cin >> a[i];
	}
}

int _abs(int f)
{
	if(f < 0) return -f;
	return f;
}

int c[MAXN][MAXN];

struct node
{
	int x, y, val;
	int prevX, prevY;

	node(int _x, int _y, int _val, int _prevX, int _prevY)
	{
		x = _x; y = _y; val = _val; prevX = _prevX; prevY = _prevY;
	}

	bool operator<(node other) const
	{
		return val > other.val;
	}
};

bool vis[MAXN][MAXN];
pair<int, int> bst[MAXN][MAXN];

const int moveX[4] = {0, 0, -1, 1};
const int moveY[4] = {-1, 1, 0, 0};

int cnt[MAXN][MAXN];

int dijkstra(int target, int type)
{
	for(int i = 0; i < n; i++)
	{
		for(int j = 0; j < m; j++)
		{
			vis[i][j] = 0;
			bst[i][j] = {-1, -1};
		}
	}
	priority_queue <node> pq;
	if(type == 0)
	{
		for(int i = 0; i < n; i++)
		{
			pq.push(node(i, 0, c[i][0], -1, -1));
		}
	}
	else
	{
		for(int i = 0; i < m; i++)
		{
			pq.push(node(0, i, c[0][i], -1, -1));
		}
	}

	while(!pq.empty())
	{
		auto tmp = pq.top(); pq.pop();

		if(vis[tmp.x][tmp.y])
		{
			continue;
		}
		bst[tmp.x][tmp.y] = {tmp.prevX, tmp.prevY};
		if(type == 0 && tmp.y == target)
		{
			int f = tmp.x, s = tmp.y;
			while(f != -1 && s != -1)
			{
				cnt[f][s]++;
				pair<int, int> ns = bst[f][s];
				f = ns.first; s = ns.second;
			}
			return tmp.val;
		}
		else if(type == 1 && tmp.x == target)
		{
			int f = tmp.x, s = tmp.y;
			while(f != -1 && s != -1)
			{
				cnt[f][s]++;
				pair<int, int> ns = bst[f][s];
				f = ns.first; s = ns.second;
			}
			return tmp.val;
		}
		vis[tmp.x][tmp.y] = true;

		for(int i = 0; i < 4; i++)
		{
			int new_x = tmp.x + moveX[i];
			int new_y = tmp.y + moveY[i];
			if(new_x >= 0 && new_x < n && new_y >= 0 && new_y < m && !vis[new_x][new_y])
			{
				pq.push(node(new_x, new_y, tmp.val + c[new_x][new_y], tmp.x, tmp.y));
			}
		}
	}
	return 0;
}

const int INF = 1e9;

void solve()
{
	int answer = INF;
	for(int t = 0; t <= 9; t++)
	{
		for(int j = 0; j < n; j++)
		{
			for(int i = 0; i < m; i++)
			{
				c[j][i] = _abs(a[j][i] - '0' - t);
			}
		}
		int ans = 0;
		ans += dijkstra(m - 1, 0);
		ans +=  dijkstra(n - 1, 1);
		for(int i = 0; i < n; i++)
		{
			for(int j = 0; j < m; j++)
			{
				if(cnt[i][j] == 2)
				{
					ans -= c[i][j];
				}
				cnt[i][j] = 0;
			}
		}
		answer = min(answer, ans);
	}
	cout << answer << "\n";
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	read_input();
	solve();

	return 0;
}
