#include<iostream>
#include<queue>
#include<cmath>
using namespace std;
int tab[1000][1000];
int path;
int lens[1000][1000][4];
int n,m;
void dijkstra_top(){
    priority_queue<pair<int,pair<int,int> > > curin;
    for(int x=0;x<m;x++){
        curin.push({-abs(path-tab[x][0]),{x,0}});
    }
    while(!curin.empty()){
        int val=-curin.top().first;
        int x=curin.top().second.first,y=curin.top().second.second;
        curin.pop();
        if(lens[x][y][0]!=-1)continue;
        lens[x][y][0]=val;
        if(x>0 && lens[x-1][y][0]==-1){
            curin.push({-val-abs(path-tab[x-1][y]),{x-1,y}});
        }
        if(x<m-1 && lens[x+1][y][0]==-1){
            curin.push({-val-abs(path-tab[x+1][y]),{x+1,y}});
        }
        if(y>0 && lens[x][y-1][0]==-1){
            curin.push({-val-abs(path-tab[x][y-1]),{x,y-1}});
        }
        if(y<n-1 && lens[x][y+1][0]==-1){
            curin.push({-val-abs(path-tab[x][y+1]),{x,y+1}});
        }
    }
    /*cout<<endl;
    for(int y=0;y<n;y++){
        for(int x=0;x<m;x++){
            cout<<lens[x][y][0]<<" ";
        }
        cout<<endl;
    }
    cout<<endl;*/
}
void dijkstra_bot(){
    priority_queue<pair<int,pair<int,int> > > curin;
    for(int x=0;x<m;x++){
        curin.push({-abs(path-tab[x][n-1]),{x,n-1}});
    }
    while(!curin.empty()){
        int val=-curin.top().first;
        int x=curin.top().second.first,y=curin.top().second.second;
        curin.pop();
        if(lens[x][y][1]!=-1)continue;
        lens[x][y][1]=val;
        if(x>0 && lens[x-1][y][1]==-1){
            curin.push({-val-abs(path-tab[x-1][y]),{x-1,y}});
        }
        if(x<m-1 && lens[x+1][y][1]==-1){
            curin.push({-val-abs(path-tab[x+1][y]),{x+1,y}});
        }
        if(y>0 && lens[x][y-1][1]==-1){
            curin.push({-val-abs(path-tab[x][y-1]),{x,y-1}});
        }
        if(y<n-1 && lens[x][y+1][1]==-1){
            curin.push({-val-abs(path-tab[x][y+1]),{x,y+1}});
        }
    }
}
void dijkstra_left(){
    priority_queue<pair<int,pair<int,int> > > curin;
    for(int y=0;y<n;y++){
        curin.push({-abs(path-tab[0][y]),{0,y}});
    }
    while(!curin.empty()){
        int val=-curin.top().first;
        int x=curin.top().second.first,y=curin.top().second.second;
        curin.pop();
        if(lens[x][y][2]!=-1)continue;
        lens[x][y][2]=val;
        if(x>0 && lens[x-1][y][2]==-1){
            curin.push({-val-abs(path-tab[x-1][y]),{x-1,y}});
        }
        if(x<m-1 && lens[x+1][y][2]==-1){
            curin.push({-val-abs(path-tab[x+1][y]),{x+1,y}});
        }
        if(y>0 && lens[x][y-1][2]==-1){
            curin.push({-val-abs(path-tab[x][y-1]),{x,y-1}});
        }
        if(y<n-1 && lens[x][y+1][2]==-1){
            curin.push({-val-abs(path-tab[x][y+1]),{x,y+1}});
        }
    }
}
void dijkstra_right(){
    priority_queue<pair<int,pair<int,int> > > curin;
    for(int y=0;y<n;y++){
        curin.push({-abs(path-tab[m-1][y]),{m-1,y}});
    }
    while(!curin.empty()){
        int val=-curin.top().first;
        int x=curin.top().second.first,y=curin.top().second.second;
        curin.pop();
        if(lens[x][y][3]!=-1)continue;
        lens[x][y][3]=val;
        if(x>0 && lens[x-1][y][3]==-1){
            curin.push({-val-abs(path-tab[x-1][y]),{x-1,y}});
        }
        if(x<m-1 && lens[x+1][y][3]==-1){
            curin.push({-val-abs(path-tab[x+1][y]),{x+1,y}});
        }
        if(y>0 && lens[x][y-1][3]==-1){
            curin.push({-val-abs(path-tab[x][y-1]),{x,y-1}});
        }
        if(y<n-1 && lens[x][y+1][3]==-1){
            curin.push({-val-abs(path-tab[x][y+1]),{x,y+1}});
        }
    }
}
int calc(){
    for(int y=0;y<n;y++){
        for(int x=0;x<m;x++){
            lens[x][y][0]=lens[x][y][1]=lens[x][y][2]=lens[x][y][3]=-1;
        }
    }
    dijkstra_top();
    dijkstra_bot();
    dijkstra_left();
    dijkstra_right();
    int cbest=100000;
    for(int y=0;y<n;y++){
        for(int x=0;x<m;x++){
            int curr=lens[x][y][0]+lens[x][y][1]+lens[x][y][2]+lens[x][y][3]-3*abs(path-tab[x][y]);
            cbest=min(cbest,curr);
        }
    }
    return cbest;
}
int main(){
    cin>>n>>m;
    for(int y=0;y<n;y++){
        for(int x=0;x<m;x++){
            char a;
            cin>>a;
            int b=a-'0';
            tab[x][y]=b;
        }
    }
    int ans=100000;
    for(int i=0;i<=9;i++){
        path=i;
        ans=min(ans,calc());
    }
    cout<<ans<<endl;
    return 0;
}
