#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x <<endl

using namespace std;

void set_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, q;
string types;
vector<vector<int>> adj_list;

void read() {
    cin >> n >> q;

    cin >> types;
    types = ' ' + types;

    adj_list.resize(n + 1);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;

        adj_list[u].emplace_back(v);
        adj_list[v].emplace_back(u);
    }
}

vector<int> parent;

void dfs(int node) {
    for (int adj_node : adj_list[node]) {
        if (adj_node != parent[node]) {
            parent[adj_node] = node;
            dfs(adj_node);
        }
    }
}

int main() {
    set_io();

    read();

    parent.resize(n + 1);

    while (q--) {
        int a, b;
        cin >> a >> b;

        parent[b] = -1;
        dfs(b);

        int node = a;
        int cnt = 0;
        int sum = 0;

        while (node != -1) {
            if (types[node] == '+') {
                sum++;
            } else {
                sum--;
            }

            if (sum > 0) {
                cnt++;
            }

            node = parent[node];
        }

        cout << cnt << endl;
    }

    return EXIT_SUCCESS;
}
