
#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x <<endl

using namespace std;

void set_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, m, t;
vector<vector<int>> adj_list;
vector<pair<int, int>> flights;

void read() {
    cin >> n >> m >> t;

    adj_list.resize(n);
    for (int i = 0; i < n; i++) {
        int cnt;
        cin >> cnt;

        for (int j = 0; j < cnt; j++) {
            int to;
            cin >> to;

            adj_list[i].emplace_back(to);
        }
    }

    flights.resize(t);
    for (auto &flight : flights) {
        cin >> flight.first >> flight.second;
    }
}

int f(int node, int day) {
    if (day == t) {
        return 0;
    }

    int best = f(node, day + 1);

    if (flights[day].first == node) {
        best = max(best, f(flights[day].second, day + 1) + 1);
    }

    for (int adj_node : adj_list[node]) {
        if (flights[day].first == adj_node) {
            best = max(best, f(flights[day].second, day + 1) + 1);
        }
    }

    return best;
}

int main() {
    set_io();

    read();

    int best = 0;

    for (int i = 0; i < n; i++) {
        best = max(best, f(i, 0));
    }

    cout << best << endl;

    return EXIT_SUCCESS;
}
