
#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x <<endl

using namespace std;

void set_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, m, t;
vector<set<int>> adj_list;
vector<pair<int, int>> flights;

void read() {
    cin >> n >> m >> t;

    adj_list.resize(n);
    for (int i = 0; i < n; i++) {
        int cnt;
        cin >> cnt;

        for (int j = 0; j < cnt; j++) {
            int to;
            cin >> to;

            adj_list[i].emplace(to);
        }
    }

    flights.resize(t);
    for (auto &flight : flights) {
        cin >> flight.first >> flight.second;
    }
}

vector<vector<int>> dp;

int main() {
    set_io();

    read();

    dp.resize(2, vector<int>(n, 0));

    int best = 1;

    dp[0][flights[0].second] = 1;

    for (int day = 1; day < t; day++) {
        int id = day % 2;

        for (int i = 0; i < n; i++) {
            dp[id][i] = max(dp[id][i], dp[id ^ 1][i]);

            if (i == flights[day].first) {
                dp[id][flights[day].second] = max(dp[id][flights[day].second], dp[id ^ 1][i] + 1);
            } else if (adj_list[i].count(flights[day].first)) {
                dp[id][flights[day].second] = max(dp[id][flights[day].second], dp[id ^ 1][i] + 1);
            }
        }

        for (int i = 0; i < n; i++) {
            best = max(best, dp[id][i]);
        }
    }

    cout << best << endl;

    return EXIT_SUCCESS;
}
