#include <iostream>
#include <queue>
#include <cmath>
#define fi first
#define se second
using namespace std;

const int MAXN = 502;
const int INF = 1 << 30;

int n, m;
char a[MAXN][MAXN];
int dist[MAXN][MAXN][4][10];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            cin >> a[i][j];
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            for (int k = 0; k < 4; ++ k)
            {
                for (int l = 0; l < 10; ++ l)
                {
                    dist[i][j][k][l] = INF;
                }
            }
        }
    }
}

void Dijkstra(int dir, int dig)
{
    priority_queue<pair<int, pair<int, int>>> pq;

    if (dir == 0) for (int i = 1; i <= m; ++ i) // from above
    {
        dist[1][i][dir][dig] = abs(dig + 48 - a[1][i]);
        pq.emplace(-dist[1][i][dir][dig], make_pair(1, i));
    }

    if (dir == 1) for (int i = 1; i <= m; ++ i) // from below
    {
        dist[n][i][dir][dig] = abs(dig + 48 - a[n][i]);
        pq.emplace(-dist[n][i][dir][dig], make_pair(n, i));
    }

    if (dir == 2) for (int i = 1; i <= n; ++ i) // from left
    {
        dist[i][1][dir][dig] = abs(dig + 48 - a[i][1]);
        pq.emplace(-dist[i][1][dir][dig], make_pair(i, 1));
    }

    if (dir == 3) for (int i = 1; i <= n; ++ i) // from right
    {
        dist[i][m][dir][dig] = abs(dig + 48 - a[i][m]);
        pq.emplace(-dist[i][m][dir][dig], make_pair(i, m));
    }

    while (!pq.empty())
    {
        int x = pq.top().se.fi;
        int y = pq.top().se.se;
        int d = -pq.top().fi;
        pq.pop();

        if (x != 1 and dist[x - 1][y][dir][dig] > d + abs(dig + 48 - a[x - 1][y]))
        {
            dist[x - 1][y][dir][dig] = d + abs(dig + 48 - a[x - 1][y]);
            pq.push(make_pair(-dist[x - 1][y][dir][dig], make_pair(x - 1, y)));
        }

        if (x != n and dist[x + 1][y][dir][dig] > d + abs(dig + 48 - a[x + 1][y]))
        {
            dist[x + 1][y][dir][dig] = d + abs(dig + 48 - a[x + 1][y]);
            pq.push(make_pair(-dist[x + 1][y][dir][dig], make_pair(x + 1, y)));
        }

        if (y != 1 and dist[x][y - 1][dir][dig] > d + abs(dig + 48 - a[x][y - 1]))
        {
            dist[x][y - 1][dir][dig] = d + abs(dig + 48 - a[x][y - 1]);
            pq.push(make_pair(-dist[x][y - 1][dir][dig], make_pair(x, y - 1)));
        }

        if (y != m and dist[x][y + 1][dir][dig] > d + abs(dig + 48 - a[x][y + 1]))
        {
            dist[x][y + 1][dir][dig] = d + abs(dig + 48 - a[x][y + 1]);
            pq.push(make_pair(-dist[x][y + 1][dir][dig], make_pair(x, y + 1)));
        }
    }
}

int main()
{
    Init();

    for (int i = 0; i < 4; ++ i)
    {
        for (int j = 0; j < 10; ++ j)
        {
            Dijkstra(i, j);
        }
    }

    int ans = 1000000000;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            for (int d = 0; d < 10; ++ d)
            {
                ans = min(ans, dist[i][j][0][d] + dist[i][j][1][d] + dist[i][j][2][d] + dist[i][j][3][d] - 3 * abs(a[i][j] - 48 - d));
            }
        }
    }

    cout << ans << endl;
    return 0;
}
